# Copyright 2017, Trimble Inc

# This software is provided as an example of using the Ruby interface
# to SketchUp.

# Permission to use, copy, modify, and distribute this software for
# any purpose and without fee is hereby granted, provided that the above
# copyright notice appear in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#-----------------------------------------------------------------------------
# Name        :   D5Converter Extension Manager
# Description :   A script that loads the D5Converter Tools as an extension to
#                 SketchUp
# Menu Item   :   Yes
# Context Menu:   Yes
# Usage       :   N/A
# Date        :   2021/7/22
# Type        :   N/A
#-----------------------------------------------------------------------------

require 'sketchup.rb'
require 'extensions.rb'
require 'langhandler.rb'

module D5Converter
  # Clear expired files
  expired_file=File.join(File.dirname(__FILE__),"su_to_d5render.rb")
  File.delete(expired_file) if File.exist?(expired_file)

  # set VERSION and ENVIRONMENT
  # VERSION = reserved.main.hotfix.build
  # ENVIRONMENT = test/cn/usa
  VERSION = "0.7.2.0001"
  ENVIRONMENT = "cn"

  # Register the Extension with SU's extension manager
  EXTENSION = SketchupExtension.new("D5 Converter", "su_to_d5render/su_to_d5render")# TODO "d5_converter/converter_menus"

  EXTENSION.description="A plugin to export SketchUp file to D5 Render."

  EXTENSION.version = VERSION
  EXTENSION.creator = "Dimension 5"
  EXTENSION.copyright = "2021, Dimension 5 Techs."

  Sketchup.register_extension EXTENSION,true

end # module D5Converter
